/*                                  */
/* copyright '99 MacroSloth, hahaha */
/*            oops, gotta go        */
/*                                  */
/*  have fun, make it better, NaN   */
/*  History:                        */
/*                                  */
/*  V1.0- bin rel. with fish demo   */
/*                                  */
/*  V1.1- src rel. many bug fixes   */
/*        added auto matrices       */
/*        added auto textures       */
/*        added auto reflections    */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "../lib/hrc.h"
#include "hrc2gbi.h"

/* output vertex count and tmp marker */
int	out_vcnt,out_vcnt_mark,tot_verts=0;


/* stupid names for debugging, just turn them all on */
/* 
#define DEBUGZ(x) x
#define DEBUG(x) x
#define DEBUGP(x) x
#define DEBUGQ(x) x
*/

#define DEBUGZ(x)
#define DEBUG(x)
#define DEBUGP(x)
#define DEBUGQ(x)

char	base[256];

/* material and texture stack - dependent on heirarchy */
/* deeper than this and you should smack your modeler's */
/* where it hurts */
#define MAXSTACK 32

int		mtlstk=0;
int		txtstk=0;
Material	*mtls[MAXSTACK];
Texture		*txts[MAXSTACK];

/* scale factor for float->.16 */
#define VTXSCALE 256

main( argc, argv, envp )
int 	argc;
char    *argv[];
char    *envp[];
{ 
	Model	*mod;
	VtxCache	vtxcache;
	char	tmp[256],cmd[256];
	int		args;

	if ( argc < 3 )
	{
		fprintf(stderr,"Usage :\n");
		fprintf(stderr,"%s in.hrc outbasename\n",argv[0]);
		exit(-1);
	}

/* oops... legacy code */
	args = 3;
	for (; args<argc;)
	{
		if ( strcmp(argv[args],"-s") == 0 )
		{
			args++;
/*
			uscale = (float)atof(argv[args]);
*/
			args++;
/*
			vscale = (float)atof(argv[args]);
*/
			args++;
		}
		else
		{
			fprintf(stderr,"Unrecognized option %s\n",argv[args]);
			exit(-1);
		}
	}

	mod = readhrc(argv[1]);
	strcpy(base,argv[2]);

	/* Main DL */
	sprintf(tmp,"%s_tmpdl.c",base);
	if (( vtxcache.dl_c = fopen(tmp,"w")) == NULL )
	{
		fprintf(stderr,"can't open %s\n",tmp);
	}

	sprintf(tmp,"%s_tmpdl.h",base);
	if (( vtxcache.dl_h = fopen(tmp,"w")) == NULL )
	{
		fprintf(stderr,"can't open %s\n",tmp);
	}

	/* matrices & c init code for them */
	sprintf(tmp,"%s_init.h",base);
	if (( vtxcache.mtx_h = fopen(tmp,"w")) == NULL )
	{
		fprintf(stderr,"can't open %s\n",tmp);
	}

	sprintf(tmp,"%s_init.c",base);
	if (( vtxcache.mtx_c = fopen(tmp,"w")) == NULL )
	{
		fprintf(stderr,"can't open %s\n",tmp);
	}

	/* model dl tri's  */
	sprintf(tmp,"%s_tmptri.c",base);
	if (( vtxcache.tri_c = fopen(tmp,"w")) == NULL )
		fprintf(stderr,"can't open %s\n",tmp);

	sprintf(tmp,"%s_tmptri.h",base);
	if (( vtxcache.tri_h = fopen(tmp,"w")) == NULL )
		fprintf(stderr,"can't open %s\n",tmp);

	sprintf(tmp,"%s_tmpvtx.c",base);
	if (( vtxcache.vtx_c = fopen(tmp,"w")) == NULL )
		fprintf(stderr,"can't open %s\n",tmp);

	sprintf(tmp,"%s.h",base);
	fprintf(vtxcache.vtx_c,"#include <ultra64.h>\n\n",tmp);
	fprintf(vtxcache.vtx_c,"#include \"%s\"\n\n",tmp);
	sprintf(tmp,"%s_init.h",base);
	fprintf(vtxcache.vtx_c,"#include \"%s\"\n\n",tmp);
	fprintf(vtxcache.vtx_c,"extern %s_dynamic %s_d;\n",basename(base),basename(base));

	/* data types for matrices */
	fprintf(vtxcache.vtx_c,"/* Begin Vertices */\n");

	/* master heirarchical DL */
	fprintf(vtxcache.dl_c,"/* Begin Master DL */\n");
	fprintf(vtxcache.dl_c,"Gfx %s_dl[] = {\n",basename(base));

	/* model DL's */
	fprintf(vtxcache.tri_c,"/* Begin Model DL */\n");

	/* c init code */
	sprintf(tmp,"%s_init.h",base);
	fprintf(vtxcache.mtx_c,"#include \"%s\"\n\n",tmp);
	fprintf(vtxcache.mtx_c,"/* Begin Matrix init code */\n");
	fprintf(vtxcache.mtx_c,"%s_dynamic %s_d;\n",basename(base),basename(base));
	fprintf(vtxcache.mtx_c,"init_%s()\n",basename(base));
	fprintf(vtxcache.mtx_c,"{\n");

	/* matrices */
	fprintf(vtxcache.mtx_h,"/* Begin Matrix data */\n");
	fprintf(vtxcache.mtx_h,"typedef struct {\n");

	vtxcache.base = (char *)basename(base);

	/* 					*/
	/* 					*/
	/* main do-it all code */
	traverse_model(&vtxcache,mod);
	/* 					*/
	/* 					*/

	/* finish off master DL */
	fprintf(vtxcache.dl_c,"gsSPEndDisplayList(),\n");
	fprintf(vtxcache.dl_c,"};\n");
	fprintf(vtxcache.dl_c,"/* End Master DL */\n\n");

	/* finish off vertices */
	fprintf(vtxcache.vtx_c,"/* End Vertices */\n\n");

	/* finish of model dl's */
	fprintf(vtxcache.tri_c,"/* End Model DL */\n\n");

	/* finish off defines & tmap info */
	fprintf(vtxcache.tri_h,"#define NVtx_%s %d\n",basename(base), tot_verts);

	/* finish off matrices */
	fprintf(vtxcache.mtx_h,"} %s_dynamic;\n",basename(base));
	fprintf(vtxcache.mtx_h,"/* End Matrix data */\n");

	/* finish off matrix init code */
	fprintf(vtxcache.mtx_c,"osWritebackDCache( &%s_d, sizeof(%s_d) );\n",
		vtxcache.base, vtxcache.base);

	fprintf(vtxcache.mtx_c,"}\n");
	fprintf(vtxcache.mtx_c,"/* End Matrix init code */\n");

	fclose(vtxcache.tri_c);
	fclose(vtxcache.tri_h);
	fclose(vtxcache.vtx_c);
	fclose(vtxcache.dl_c);
	fclose(vtxcache.dl_h);
	fclose(vtxcache.mtx_c);
	fclose(vtxcache.mtx_h);

	sprintf(cmd,"cat %s_tmpvtx.c %s_tmptri.c %s_tmpdl.c > %s.c\n",
		base,base,base,base);
	if ( system(cmd) ) perror(cmd);

	sprintf(cmd,"rm %s_tmpvtx.c %s_tmptri.c %s_tmpdl.c \n", 
		base,base,base);
	if ( system(cmd) ) perror(cmd);

	sprintf(cmd,"cat %s_tmptri.h %s_tmpdl.h > %s.h\n", 
		base,base,base);
	if ( system(cmd) ) perror(cmd);

	sprintf(cmd,"rm %s_tmptri.h %s_tmpdl.h\n", 
		base,base);
	if ( system(cmd) ) perror(cmd);

	exit(0);
}

void	traverse_model(vcache,mod)
VtxCache	*vcache;
Model	*mod;
{
	int	i,j,done,popmtx;
	Llist	*child;
	char	*modname,*quote;

	done = popmtx = 0;

	/* fix model name eg: "name" */
	modname = (char *)strchr(mod->name,'"');
	modname++;
	quote = (char *)strchr(modname,'"');
	*quote = '\0';

	vcache->vname = modname;

	/* if scale,rot or trans are not ident dump them, */
	/* optimized: popmtx = need to know if we have to pop */
	popmtx = push_matrix( vcache,mod );

	/* push materials and textures */
	push_mtltxt( vcache,mod );

	dump_model(vcache,mod);

	child = &(mod->childlist);

	while ( !done )
	{
		if ( child->ptr != (void *)NULL )
			traverse_model(vcache,child->ptr);

		if ( child->next == (Llist *)NULL )
			done = 1;
		else
		{
			child = child->next;
		}
	}
	pop_mtltxt( vcache,mod );
	if ( popmtx ) pop_matrix(vcache,mod);
}

void	 push_mtltxt( vcache,mod )
VtxCache	*vcache;
Model	*mod;
{
	/* push txt onto stack */
	txts[txtstk] = mod->txtlist.ptr;
	txtstk++;

	/* push mtl onto stack */
	mtls[mtlstk] = mod->mtllist.ptr;
	mtlstk++;
}

int		 push_matrix( vcache,mod )
VtxCache	*vcache;
Model	*mod;
{
	if ((mod->scale[0] == 1.0) 
	&   (mod->scale[1] == 1.0) 
	&   (mod->scale[2] == 1.0)
	&   (mod->translate[0] == 0.0) 
	&   (mod->translate[1] == 0.0) 
	&   (mod->translate[2] == 0.0)
	&   (mod->rotate[0] == 0.0) 
	&   (mod->rotate[1] == 0.0) 
	&   (mod->rotate[2] == 0.0)) {
		return(0);
	}
	else {
		/* output matrix variable */
		fprintf(vcache->mtx_h,"Mtx	%s_mat;\n",vcache->vname);

		/* init code for matrix */
		fprintf(vcache->mtx_c,"mkmat_srt( &%s_d.%s_mat,\\\n",vcache->base,
			vcache->vname);
		fprintf(vcache->mtx_c,"%f, %f, %f,\\\n",
			mod->scale[0],mod->scale[1],mod->scale[2]);
		fprintf(vcache->mtx_c,"%f, %f, %f,\\\n",
			mod->rotate[0],mod->rotate[1],mod->rotate[2]);
		fprintf(vcache->mtx_c,"%f, %f, %f );\n\n",
			mod->translate[0]*VTXSCALE,mod->translate[1]*VTXSCALE,mod->translate[2]*VTXSCALE);

		/* dl matrix entry */
		fprintf(vcache->dl_c,"gsSPMatrix(&%s_d.%s_mat,",vcache->base,
			vcache->vname);
		fprintf(vcache->dl_c,"G_MTX_MODELVIEW|G_MTX_MUL|G_MTX_PUSH),\n");

		return(1);
	}
}

void	pop_matrix(vcache,mod)
VtxCache	*vcache;
Model	*mod;
{
	fprintf(vcache->dl_c,"gsSPPopMatrix(G_MTX_MODELVIEW),\n");
}

void	pop_mtltxt(vcache,mod)
VtxCache	*vcache;
Model	*mod;
{
	txtstk--;
	if (txtstk < 0 ) txtstk=0;

	mtlstk--;
	if (mtlstk < 0 ) mtlstk=0;
}

void	dump_model(vcache,mod)
VtxCache	*vcache;
Model	*mod;
{
	Mesh	*mesh;
	Vertex	*vlist;
	Polygon	*plist;
	Node	*nlist;
	Edge	*elist;
	int	i,j,pnum,vj,endtri,ntrileft,outtris,best,repu,repv;

	mesh = mod->mesh;
	/* no model, maybe matrix (a null) */
	if ( mesh == (Mesh *)NULL ) return;

	/* make tri's variable */
	fprintf(vcache->tri_c,"Gfx %s_dl[] = {\n", vcache->vname);

	/* output bbox cull first 8 verts are allways cull pnts */
	fprintf(vcache->tri_c,"\ngsSPVertex(&%s_v[0],8,0),",vcache->vname);
	fprintf(vcache->tri_c,"\ngsSPCullDisplayList(0,7),\n");

	/* make vertex variable */
	fprintf(vcache->vtx_c,"Vtx_tn %s_v[] = {\n", vcache->vname);

	out_vcnt = 0;	/* output vertex count */

	/* output bbox verts */
	output_bbox(vcache,mesh);

	/* output material and texture info. */
	output_mtltxt( vcache, mod );

	/* make dl entry */
	fprintf(vcache->dl_c,"\ngsSPDisplayList(%s_dl),\n\n", vcache->vname);

	polynorms( mesh );
	/* this routine apply the normals to the actual */
	/* vertex, as opposed to the face node's */
	pointnorms( mesh );

	vlist = mesh->vertlist;
	plist = mesh->polylist;
	elist = mesh->edgelist;

	/* init points' nrefs to 0 */
	/* nref's is how many time a vertex is used by surrounding poly's */
	for (i=0; i<mesh->nverts; i++) {
		/* #refs */
		vlist[i].w = 0.0;
		/* cache vnum */
		vlist[i].tmp = 0;

		vlist[i].flag = 0;

		/* where uv's are going */
		vlist[i].d[0] = 0;
		vlist[i].d[1] = 0;
	};

	/* copy node's uv's to vertex */
	/* also build point references */
	/* ie: how many times a point is used by the polys */

	for (i=0; i<mesh->npolys; i++)
	{
		if ( plist[i].nodes > 3 ) {
			fprintf(stderr,"Model should be triangulated\n");
			exit(-1);
		}

		nlist = plist[i].nodelist;

		for (j=0; j<plist[i].nodes; j++)
			vlist[nlist[j].vnum].w += 1.0; /* incr. nrefs */

		/* stuff uv's in unused struct of vertex */
		for (j=0; j<plist[i].nodes; j++) {
			vlist[nlist[j].vnum].d[0] = nlist[j].uv[0];
			vlist[nlist[j].vnum].d[1] = nlist[j].uv[1];
		}
	}

	init_cache(vcache);	/* reset */

	ntrileft = mesh->npolys;

	DEBUG(fprintf(stdout,"building edgelist\n");)

	/* make each vertex have a list of connected edges */
	buildvtxedgelist(mesh);

	outtris = 0;
	while (1) {
		/* search surrounding points for most nrefs */
		best = find_best_point(vcache,mesh);
		DEBUGP(fprintf(stderr,"best %d\n",best);)

		if ( best < 0 ) {
			outtris = flush_cache(vcache,mesh);	/* tri's and points get outputed here */
			DEBUGQ(fprintf(stderr,"*** Last flush %s outtris %d\n",vcache->vname,outtris);)
			ntrileft -= outtris;
			DEBUGQ(fprintf(stderr,"*** ntrisleft %d\n",ntrileft);)
			break;	/* no points left */
		}

		if ( !add_cache(vcache,mesh,best)) {
			outtris = flush_cache(vcache,mesh);	/* tri's and points get outputed here */
			DEBUGP(fprintf(stderr,"outtris %d\n",outtris);)

			if ( !add_cache(vcache,mesh,best) ) {
				fprintf(stderr,"Panic- double add_cache failure...\n");
				exit(-1);
			}

		}

		/* each new point _should_ complete a tri (except on restarts) */
		if ( outtris != 0 ) {
			ntrileft -= outtris;
			DEBUGP(fprintf(stderr,"ntrileft = %d\n",ntrileft);)
			outtris = 0;

			if ( ntrileft < 0 ) {
				/* yikes - should not happen */
				fprintf(stderr,"yikes- ntrileft < 0!\n");
				exit(-1);
			}
		}
	}

	/* end tri dl */
	fprintf(vcache->tri_c,"gsSPEndDisplayList(),\n");
	fprintf(vcache->tri_c,"};\n");

	/* statistics */
	fprintf(vcache->tri_h,"#define NVtx_%s %d\n",vcache->vname, out_vcnt);
	fprintf(vcache->tri_h,"#define NTri_%s %d\n",vcache->vname, mesh->npolys);
	tot_verts += out_vcnt;

	/* end vertices */
	fprintf(vcache->vtx_c,"};\n");
}

void	init_cache(vcache)
VtxCache *vcache;
{
	int	i;

	DEBUGP(fprintf(stderr,"init cache\n");)

	vcache->prevfirstcontig = -1;
	vcache->firstcontig = 0;
	vcache->nextcontig = 0;
	vcache->lastcontig = 16;
	vcache->blowout = 0;

	for (i=0; i<16; i++) {
		vcache->cpnt[i].vnum = VNUM_NULL;
		vcache->cpnt[i].flag = CPOINT_EMPTY;
	}
}

/* search cache point's edges for the point which completes */
/* the most number of edges of points in cache*/
/* */

int	find_best_point(vcache,mesh)
VtxCache	*vcache;
Mesh	*mesh;
{
	int	vcandidatelist[128]; /* vertex candidate list (too large??) */
	int	ncandidates=0,vcandidate;
	Edge	*elist;
	Vertex	*vlist;
	Llist	*edgelist;	/* linked list */
	int	i,vnum,edge,done;
	int	maxoccurvtx,maxoccur,curroccur,lastvtx;

	elist = mesh->edgelist;
	vlist = mesh->vertlist;

	DEBUGP(fprintf(stderr,"find best point\n");)

	/* step though all cache points */
	for (i=0; i<16; i++) {
		/* valid cache point? */
		if ( vcache->cpnt[i].flag & CPOINT_USED ) {
			vnum = vcache->cpnt[i].vnum;

			edgelist = &(vlist[vnum].elist);

			edge = (int)edgelist->ptr;
			if ( edge != 0 ) {
				/* step through all edges */
				done = 0;
				while ( !done ) {
					/* if edge < 0 then this vtx is at v1 not v0 */
					if ( edge < 0 ) {
						vcandidate = elist[(-edge)].vptr0;
					}
					else {
						vcandidate = elist[edge].vptr1;
					}

					/* not in cache already.. and not finished */
					if ( !(vlist[vcandidate].flag & CPOINT_CACHED) )
						if ( !(vlist[vcandidate].flag & CPOINT_OUTPUTED) )
							vcandidatelist[ncandidates++] = vcandidate;

					if ( edgelist->next != (void *)NULL )
					{
						edgelist = edgelist->next;
						edge = (int)edgelist->ptr;
					}
					else
						done = 1;
				}
			} /* edge !=0 */
		} /* valid cache point */
	} /* i */

	/* if no candidates, we re-seed the cache */
	if ( ncandidates == 0 ) {
		DEBUGP(fprintf(stderr,"reseed cache\n");)
		DEBUGP( for (i=0; i<16; i++)	\
				if ( vcache->cpnt[i].flag & CPOINT_USED )	\
					fprintf(stderr,"cpnt i %d v %d ",i, vcache->cpnt[i].vnum);	\
				fprintf(stderr,"\n"); )

		/* find new candidate */
		for (i=0; i<mesh->nverts; i++) {
			if ( !(vlist[i].flag & CPOINT_CACHED) ) {
			  if ( !(vlist[i].flag & CPOINT_OUTPUTED) ) {
				vcandidatelist[0] = i;
				ncandidates = 1;
				break;
			  }
			}
		}
		 /* if we made it this far then were done */
		if (( ncandidates == 0 ) && ( i == mesh->nverts )) {
			DEBUGP(fprintf(stderr,"No more points\n");)
			return(-1);
		}
	}

	if ( ncandidates != 1 ) {
		qsort(vcandidatelist,ncandidates,sizeof(int),cmpintinc);
		maxoccurvtx = -1;
		maxoccur = 0;
	}
	else {
		maxoccurvtx = vcandidatelist[0];
		maxoccur = 1;
	}

	/* find the vertex that occur most in the list */
	/* vcandidatelist[] may look like this: */
	/* 1122234455555 */
	lastvtx = vcandidatelist[0];
	curroccur = 1;
	for (i=1; i<ncandidates; i++) {
		if ( vcandidatelist[i] == lastvtx ) {
			curroccur++;
		}
		else {
			if ( curroccur > maxoccur ) {
				maxoccurvtx = lastvtx;
				maxoccur = curroccur;
			}
			lastvtx = vcandidatelist[i];
			curroccur = 1;
		}
	}
	if ( curroccur > maxoccur ) {
		maxoccurvtx = lastvtx;
		maxoccur = curroccur;
	}

	DEBUGP(	\
		fprintf(stderr,"candidates:");	\
		for(i=0; i<ncandidates; i++)	\
			fprintf(stderr,"%d ",vcandidatelist[i]);	\
		fprintf(stderr,"\n:"); )

	DEBUGP(fprintf(stderr,"Maxoccur %d curroccur %d ncandidates %d\n",maxoccur,curroccur,ncandidates);)
	/* this should be it! */
	return(maxoccurvtx);
}

/* compare routine for qsort() */
int	cmpintinc( a,b )
int	*a,*b;
{
	if ( *a < *b ) 
		return(-1);
	else
		return(1);
}

int	cmpintdec( a,b )
int	*a,*b;
{
	if ( *a >= *b ) 
		return(-1);
	else
		return(1);
}

/* add point to cache list */
/* chech for full, flag cache point and main vlist */

int		add_cache(vcache,mesh,vnum)
VtxCache	*vcache;
Mesh	*mesh;
int		vnum;
{
	int	i,cnt=0;

#ifdef NOISE
	/* number of cache points used */
	for (i=0; i<16; i++)
		if ( vcache->cpnt[i].flag & CPOINT_USED ) cnt++;

	fprintf(stderr,"add cache num in cache %d\n",cnt);
#endif

	/* contiguous cache area full */
	if ( vcache->nextcontig == vcache->lastcontig )
		return(0);

	vcache->cpnt[vcache->nextcontig].vnum = vnum;
	vcache->cpnt[vcache->nextcontig].flag |= CPOINT_USED;
	vcache->nextcontig++;

	/* flag main vlist point- for use when outputing tri's */
	/* and finding surrounding uncached points */
	mesh->vertlist[vnum].flag |= CPOINT_CACHED;
	return(1);
}

/* find tri's that are completed, subtracting 1 from nrefs of tri verts */
/* move verts that are "done" (nrefs==0) to top or bottom */
/* of list so that holes in cache are contiguous */
/* we can't move previously moved points. Lastly, output points */
/* that aren't "in" the cache- ie: outputed previously */
/* then output tri's now that we know their cvnum's */
/* nuke tri's from mesh list (tri.flag=TRI_DONE) */
/* reclaim empty cache points, and find contigous */
/* region in cache for add_cache	*/

typedef struct CacheRef {
	int	vnum;
	int	nrefs;
} CacheRef;

int	flush_cache(vcache,mesh)
VtxCache	*vcache;
Mesh	*mesh;
{
	int	ret;
	CacheRef	cvlist[32]; /* cache vertex list */
	int	ncpnts=0,i,sortincr,sortdecr;
	int	firstoccur,maxoccur,curroccur;
	Vertex	*vlist;

	DEBUGP(fprintf(stderr,"flush cache \n");)

	vlist = mesh->vertlist;

	/* finds and deref's vertex nrefs by -1 */
	ret = find_tris_completed(vcache,mesh);

	/*  sort by least # refs' - this means vert's */
	/* most likely to be "done" next time will be */
	/* coherent in cache */

	/* first build list */
	for (i=vcache->firstcontig; i<vcache->lastcontig; i++) {
		/* Normally all cache points are used, but on */
		/* the very last flush we may have some unused pnts */
		if ( vcache->cpnt[i].flag & CPOINT_USED ) {
			cvlist[ncpnts  ].vnum = vcache->cpnt[i].vnum;
			cvlist[ncpnts++].nrefs = vlist[vcache->cpnt[i].vnum].w;
		}
		else {
			vcache->lastcontig = i;
			break;
		}
	}

	/* see if cache point befor firstcontig, or after lastcontig */
	/* has 0 nrefs- if so sort so that least nrefs are physically */
	/* closer to it */

	if ( vcache->firstcontig == 0 ) 
		/* 1st cache point- sort increasing */
		sortincr = 512; /* lots of nrefs */
	else
		sortincr = vlist[vcache->cpnt[vcache->firstcontig - 1].vnum ].w;

	if ( vcache->lastcontig == 16 ) 
		/* last cache point- sort decreasing */
		sortdecr = 512; /* lots of nrefs */
	else
		sortdecr = vlist[vcache->cpnt[vcache->lastcontig].vnum ].w;

	DEBUGQ(fprintf(stderr,"B");
	for (i=0; i<ncpnts; i++)
		fprintf(stderr,"cv %d %d :",i,cvlist[i].nrefs);
	fprintf(stderr,"\n");)

	if ( sortincr > sortdecr ) {
		/* increasing order */
		DEBUGQ(fprintf(stderr,"increasing\n");)
		qsort(cvlist,ncpnts,sizeof(CacheRef),incr_cref);
	}
	else {
		/* decreasing order */
		DEBUGQ(fprintf(stderr,"decreasing\n");)
		qsort(cvlist,ncpnts,sizeof(CacheRef),decr_cref);
	}

	/* now shove them into cache */
	for (i=vcache->firstcontig; i<vcache->lastcontig; i++) {
		vcache->cpnt[i].vnum = cvlist[i-vcache->firstcontig].vnum;
	}

	DEBUGQ(fprintf(stderr,"E");
	for (i=0; i<ncpnts; i++)
		fprintf(stderr,"cv %d %d :",i,cvlist[i].nrefs);
	fprintf(stderr,"\n");)

	/* mark where to find this chunk in vertex output list */
	out_vcnt_mark = out_vcnt;

	/* now assign cache vnums to master vlist's cvnums */
	/* we use an unused struct in vertex for cvnum */
	/* we don't need to reprocess cached points */
	/* cache vnum is implied by position in array */

	for (i=0; i<16; i++) {
		if (( vcache->cpnt[i].flag & CPOINT_USED ) 
		&& !(vcache->cpnt[i].flag & CPOINT_CACHED )) {
			/* assign cache vnum */
			vlist[vcache->cpnt[i].vnum].tmp = i;

			/* output vertex */
			output_vertex(vcache,i,mesh);

			/* now mark cpnt as "cached" */
			vcache->cpnt[i].flag |= CPOINT_CACHED;
		}
	}

	/* outputs triangles and mark them done */
	/* do this before we nuke firstcontig et al */
	output_tris_completed(vcache,mesh);

	/* find "done" verts */
	/* build contigous list */
	firstoccur = 0;
	curroccur = 0;
	maxoccur = 0;
	for (i=0; i<16; i++) {
		if ( vcache->cpnt[i].flag == CPOINT_EMPTY ) {
			curroccur++;
		}
		else {
			if ( vlist[vcache->cpnt[i].vnum].w == 0.0 ) {
				curroccur++;
				/* init vcpnt */
				vcache->cpnt[i].vnum = -1;
				vcache->cpnt[i].flag = CPOINT_EMPTY;
			}
			else {
				if ( curroccur > maxoccur ) {
					firstoccur = i-curroccur;
					maxoccur = curroccur;
				}
				curroccur = 0;
			}
		}
	}
	/* end condition */
	if ( curroccur > maxoccur ) {
		firstoccur = i-curroccur;
		maxoccur = curroccur;
	}

	if (maxoccur == 0) {
		/* cache really full */
		/* blowout 4 verts out */
		/* less vert result in smaller file, but more &SPVertex() */
		/* not- sure which is worse */

		DEBUGQ(fprintf(stderr,"*** cache blowout ***\n");)

		/* blowout next 4 vert's base on last blowout */
		/* this keeps us from infinite load/blowout loops */

		firstoccur = vcache->blowout*4;
		vcache->blowout++;
		vcache->blowout %= 4;
		maxoccur = 4;

#ifdef NOGOOD
		/* optimizing is not easy... */

		/* try not to blowover verts just inserted */
		if (( vcache->prevfirstcontig >= firstoccur ) 
		&&  ( vcache->prevfirstcontig < firstoccur+maxoccur )) {
			firstoccur = vcache->blowout*3;
			vcache->blowout++;
			vcache->blowout %= 5;
			maxoccur = 3;
		}
#endif

		/* shouldn't happen- paranoid checking */
		for (i=0; i< 16; i++)
			if ( !(vcache->cpnt[i].flag & CPOINT_USED) ) {
				fprintf(stderr,"Cache point not used... but cache blowout\n");
				fprintf(stderr,"flag = %d,i=%d vnum=%d\n",
					vcache->cpnt[i].flag,i,vcache->cpnt[i].vnum);
				
			}

		for (i=firstoccur; i< (firstoccur+maxoccur); i++) {
			/* valid points only-they should all be used.... */
			if ( vcache->cpnt[i].flag & CPOINT_USED ) {
				/* unflag vlist so tri doesnt accidentally get outputed */
				vlist[vcache->cpnt[i].vnum].flag = CPOINT_EMPTY;
				vcache->cpnt[i].vnum = -1;
				vcache->cpnt[i].flag = CPOINT_EMPTY;
			}
		}
	}

	vcache->prevfirstcontig = vcache->firstcontig;
	vcache->firstcontig = firstoccur;
	vcache->lastcontig = firstoccur+maxoccur;
	vcache->nextcontig = firstoccur;

	DEBUGP(fprintf(stderr,"firstcontig %d lastcontig %d\n",
		vcache->firstcontig,vcache->lastcontig);)

	return(ret);
}

/* increasing check for qsort() */
int	incr_cref( a,b )
CacheRef	*a,*b;
{
	if ( a->nrefs < b->nrefs ) 
		return(-1);
	else
		return(1);
}

/* decreasing check for qsort() */
int	decr_cref( a,b )
CacheRef	*a,*b;
{
	if ( a->nrefs > b->nrefs ) 
		return(-1);
	else
		return(1);
}


/* unused routine */
/* start optimizing again, and gave up for now... */
int will_complete_tris(vcache,mesh,vnum)
VtxCache	*vcache;
Mesh	*mesh;
int		vnum;
{
	Vertex	*vlist;
	Polygon	*plist;
	Node	*nlist;
	int		i,j;
	int		cnt=0;

	plist = mesh->polylist;
	vlist = mesh->vertlist;

	vlist[vnum].flag |= CPOINT_CACHED;

	for (i=0; i<mesh->npolys; i++) {
		nlist = plist[i].nodelist;

		if ( !(plist[i].flag & TRI_DONE) ) {
			if (( vlist[nlist[0].vnum].flag & CPOINT_CACHED )
			&&  ( vlist[nlist[1].vnum].flag & CPOINT_CACHED )
			&&  ( vlist[nlist[2].vnum].flag & CPOINT_CACHED )) {
				cnt++;
			}
		}
	}
	vlist[vnum].flag ^= CPOINT_CACHED;

	return(cnt);
}

int	find_tris_completed(vcache,mesh)
VtxCache	*vcache;
Mesh	*mesh;
{
	Vertex	*vlist;
	Polygon	*plist;
	Node	*nlist;
	int		i,j;
	int		cnt=0;

	DEBUGP(fprintf(stderr,"find tris completed\n");)

	plist = mesh->polylist;
	vlist = mesh->vertlist;

	for (i=0; i<mesh->npolys; i++) {
		nlist = plist[i].nodelist;
		/* all tri's by now */

		if ( !(plist[i].flag & TRI_DONE) ) {
			if (( vlist[nlist[0].vnum].flag & CPOINT_CACHED )
			&&  ( vlist[nlist[1].vnum].flag & CPOINT_CACHED )
			&&  ( vlist[nlist[2].vnum].flag & CPOINT_CACHED )) {
				vlist[nlist[0].vnum].w -= 1.0;
				vlist[nlist[1].vnum].w -= 1.0;
				vlist[nlist[2].vnum].w -= 1.0;
				cnt++;
			}
		}
	}
	return(cnt);
}

void	output_tris_completed(vcache,mesh)
VtxCache	*vcache;
Mesh	*mesh;
{
	Vertex	*vlist;
	Polygon	*plist;
	Node	*nlist;
	int		i,j;

	DEBUGP(fprintf(stderr,"output tris completed\n");)

	plist = mesh->polylist;
	vlist = mesh->vertlist;

	fprintf(vcache->tri_c,"gsSPVertex( &%s_v[%d],%d,%d ),\n", 
		vcache->vname,
		out_vcnt_mark,
		(vcache->lastcontig - vcache->firstcontig),
		vcache->firstcontig );

	for (i=0; i<mesh->npolys; i++) {
		nlist = plist[i].nodelist;
		/* all tri's by now */

		if ( !(plist[i].flag & TRI_DONE) ) {

			if (( vlist[nlist[0].vnum].flag & CPOINT_CACHED )
			&&  ( vlist[nlist[1].vnum].flag & CPOINT_CACHED )
			&&  ( vlist[nlist[2].vnum].flag & CPOINT_CACHED )) {

			/* cache vnums are in tmp */
				fprintf(vcache->tri_c,"gsSP1Triangle( %d, %d, %d, 0),\n",
					vlist[nlist[0].vnum].tmp,
					vlist[nlist[1].vnum].tmp,
					vlist[nlist[2].vnum].tmp );
		
				plist[i].flag |= TRI_DONE;
			}
		}
	}
}

#define TXT_SC 0x8000
#define TXT_TC 0x8000

/* use in vtx output */
#define VTX_SC 2
#define VTX_TC 2

/* should be vars */
#define PIC_W 32
#define PIC_H 32

#define WRAPBITSX 5
#define WRAPBITSY 5

void	output_mtltxt( vcache, mod )
VtxCache	*vcache;
Model	*mod;
{
	Texture	*txt;
	Material	*mtl;
	char	*texture,*tmp;
	unsigned	char	c,r,g,b;

	txt = txts[txtstk-1];
	mtl = mtls[mtlstk-1];

	if ( txt != (Texture *)NULL ) {

		texture = (char *)basename(txt->picname);
		tmp = (char *)strchr(texture,'"');
		if ( tmp != (char *)NULL ) *tmp = '\0';

		DEBUGP(fprintf(stderr,"picname %s\n",texture);)

		/* another hack- keep this handy for later */
		vcache->uscale = txt->repeat[0];
		vcache->vscale = txt->repeat[1];
		vcache->swap = txt->uvswap;

		DEBUGZ(fprintf(stderr,"uscale %f vscale %f\n",
			vcache->uscale,vcache->vscale);)

		/* tmap pixel data variable name */
		fprintf(vcache->dl_h,"extern unsigned short %s[];\n", texture);

		if ( strcmp( (char *)get_symname( txt->method ),"UV") == 0) {
			/* texture scale down factor of .5 = 0x8000 in .16 format */
			fprintf(vcache->dl_c,"gsSPClearGeometryMode( G_TEXTURE_GEN ),\n");
			fprintf(vcache->dl_c,"gsSPTexture( %d,%d,0,0, G_ON),\n",TXT_SC,TXT_TC);
  			fprintf(vcache->dl_c,"gsDPSetCombineMode(G_CC_MODULATERGB, G_CC_MODULATERGB),\n");
  			fprintf(vcache->dl_c,"gsDPSetTexturePersp(G_TP_PERSP),\n");
  			fprintf(vcache->dl_c,"gsDPSetTextureLOD(G_TL_TILE),\n");
  			fprintf(vcache->dl_c,"gsDPSetTextureDetail(G_TD_CLAMP),\n");
  			fprintf(vcache->dl_c,"gsDPSetTextureFilter(G_TF_BILERP),\n");
  			fprintf(vcache->dl_c,"gsDPSetTextureConvert(G_TC_FILT),\n");
  			fprintf(vcache->dl_c,"gsDPSetTextureLUT(G_TT_NONE),\n");

			fprintf(vcache->dl_c,"gsDPLoadTextureBlock( %s , G_IM_FMT_RGBA, \n",texture);
			fprintf(vcache->dl_c,"G_IM_SIZ_16b, %d, %d, 0, G_TX_WRAP | G_TX_NOMIRROR,\n",PIC_W,PIC_H);
			fprintf(vcache->dl_c,"G_TX_WRAP | G_TX_NOMIRROR, %d, %d,\n",WRAPBITSX,WRAPBITSY);
			fprintf(vcache->dl_c," G_TX_NOLOD, G_TX_NOLOD),\n");
		}
		else {
			/* reflection map */
			if ( strcmp( (char *)get_symname( txt->method ),"WITHOUT_REFLECT") == 0) {
				/* texture scale down factor of .03125 = 0x800 in .16 format */
				fprintf(vcache->dl_c,"gsSPSetGeometryMode( G_TEXTURE_GEN ),\n");
				fprintf(vcache->dl_c,"gsSPTexture( 0x800,0x800,0,0, G_ON),\n");
  				fprintf(vcache->dl_c,"gsDPSetCombineMode(G_CC_HILITERGB, G_CC_HILITERGB),\n");
  				fprintf(vcache->dl_c,"gsDPSetTexturePersp(G_TP_PERSP),\n");
  				fprintf(vcache->dl_c,"gsDPSetTextureLOD(G_TL_TILE),\n");
  				fprintf(vcache->dl_c,"gsDPSetTextureDetail(G_TD_CLAMP),\n");
  				fprintf(vcache->dl_c,"gsDPSetTextureFilter(G_TF_BILERP),\n");
  				fprintf(vcache->dl_c,"gsDPSetTextureConvert(G_TC_FILT),\n");
  				fprintf(vcache->dl_c,"gsDPSetTextureLUT(G_TT_NONE),\n");

				fprintf(vcache->dl_c,"gsDPLoadTextureBlock( %s , G_IM_FMT_RGBA, \n",texture);
				fprintf(vcache->dl_c,"G_IM_SIZ_16b, %d, %d, 0, G_TX_WRAP | G_TX_NOMIRROR,\n",PIC_W,PIC_H);
				fprintf(vcache->dl_c,"G_TX_WRAP | G_TX_NOMIRROR, %d, %d,\n",WRAPBITSX,WRAPBITSY);
				fprintf(vcache->dl_c," G_TX_NOLOD, G_TX_NOLOD),\n");

				/* shininess */
				if ( mtl != (Material *)NULL )
					c = 255 * mtl->rfl;
				else
					c = 255;

				fprintf(vcache->dl_c,"gsDPSetPrimColor(0,0,%d,%d,%d,255),\n",c,c,c);
			}
		} /* end uv methods */
	} /* txt shit */

	/* light color */
	if ( mtl != (Material *)NULL ) {
		/* mtl with no txt */
		if ( txt == (Texture *)NULL ) {
			fprintf(vcache->dl_c,"gsSPClearGeometryMode( G_TEXTURE_GEN ),\n");
			fprintf(vcache->dl_c,"gsDPSetCombineMode(G_CC_SHADE, G_CC_SHADE),\n");
		}
		r = 255*mtl->diff[0]; 
		g = 255*mtl->diff[1]; 		
		b = 255*mtl->diff[2];
		/* material color */
		fprintf(vcache->dl_c,"gsSPLightColor(LIGHT_1,0x%x),\n",(r<<24 | g<<16 | b<<8 | 255));
	}
}


void	output_vertex(vcache,cnum,mesh)
VtxCache	*vcache;
int	cnum;
Mesh	*mesh;
{
	float	u,v;
	int		vnum;
	Vertex	*vlist;

	DEBUGP(fprintf(stderr,"output vertex\n");)

	vlist = mesh->vertlist;

	vnum = vcache->cpnt[cnum].vnum;
	vlist[vnum].flag |= CPOINT_OUTPUTED;

	fprintf(vcache->vtx_c,"{ { %hd, %hd, %hd }, ",
		(short)(vlist[vnum].p[0]*VTXSCALE),
		(short)(vlist[vnum].p[1]*VTXSCALE),
		(short)(vlist[vnum].p[2]*VTXSCALE) );

	if ( vcache->swap ) {
		u = vlist[vnum].d[0] * vcache->uscale;
		v = vlist[vnum].d[1] * vcache->vscale;
	}
	else {
		u = vlist[vnum].d[1] * vcache->vscale;
		v = vlist[vnum].d[0] * vcache->uscale;
	}

	fprintf(vcache->vtx_c,"%ho ,{ %hu, %hu }, ",
		(unsigned short)0, 	/* flag */
		(unsigned short)( (float)(u * (float) ((int)((VTX_SC * PIC_W) << 5)) ) ),
		(unsigned short)( (float)(v * (float) ((int)((VTX_TC * PIC_H) << 5)) ) ));

	fprintf(vcache->vtx_c,"{ %d, %d, %d }, 255 },\n",
		(int)(vlist[vnum].n[0] * -127.0),
		(int)(vlist[vnum].n[1] * -127.0),
		(int)(vlist[vnum].n[2] * -127.0));

	DEBUGQ(fprintf(stderr,"vtx %f %f %f vnum=%d\n",
		vlist[vnum].p[0],
		vlist[vnum].p[1],
		vlist[vnum].p[2],
		vnum);)

	out_vcnt++;
}

void	output_bbox(vcache,mesh)
VtxCache	*vcache;
Mesh	*mesh;
{
	float	v[3];

	v[0] = mesh->bbox_min[0];
	v[1] = mesh->bbox_min[1];
	v[2] = mesh->bbox_min[2];

	/* -lower left */
	print_bboxv(vcache->vtx_c,v);
	out_vcnt++;

	/* -lower right */
	v[0] = mesh->bbox_max[0];
	print_bboxv(vcache->vtx_c,v);
	out_vcnt++;

	/* -upper right */
	v[1] = mesh->bbox_max[1];
	print_bboxv(vcache->vtx_c,v);
	out_vcnt++;

	/* -upper left */
	v[0] = mesh->bbox_min[0];
	print_bboxv(vcache->vtx_c,v);
	out_vcnt++;

	v[0] = mesh->bbox_max[0];
	v[1] = mesh->bbox_max[1];
	v[2] = mesh->bbox_max[2];

	/* +upper right */
	print_bboxv(vcache->vtx_c,v);
	out_vcnt++;

	/* +upper left */
	v[0] = mesh->bbox_min[0];
	print_bboxv(vcache->vtx_c,v);
	out_vcnt++;

	/* +lower left */
	v[1] = mesh->bbox_min[1];
	print_bboxv(vcache->vtx_c,v);
	out_vcnt++;

	/* +lower right */
	v[0] = mesh->bbox_max[0];
	print_bboxv(vcache->vtx_c,v);
	out_vcnt++;
}

void	print_bboxv(fp,v)
FILE	*fp;
float	*v;
{
	fprintf(fp,"{ { %hd, %hd, %hd }, ",
		(short)(v[0]*VTXSCALE),
		(short)(v[1]*VTXSCALE),
		(short)(v[2]*VTXSCALE) );

	/* uv */
	fprintf(fp,"%ho ,{ %hu, %hu }, ",
		(unsigned short)0, 	/* flag */ 
		(unsigned short)0, (unsigned short)0);

	/* norm */
	fprintf(fp,"{ %d, %d, %d }, 255 },\n", (int)0, (int)0, (int)0);
}
