
#define VNUM_NULL -1
#define CNUM_NULL -1
#define EDGENUM_NULL -1

/* flags for triangles */
#define TRI_DONE	1

/* flags for cache points */
/* empty cache point */
#define CPOINT_EMPTY 	0

/* added to cache but not outputed yet */
#define CPOINT_USED		1	

/* already outputed */
#define CPOINT_CACHED	2

/* vertex flag for outputed */
#define CPOINT_OUTPUTED	4

typedef struct CachePoint {
	int	vnum;	/* vnum in main list 0-nverts */
	int	flag;
} CachePoint;

#define MAXSTK 16

typedef struct VtxCache {
	/* cache vnum is implied position in array */
	CachePoint	cpnt[16];
	int			prevfirstcontig;
	int			firstcontig;
	int			nextcontig;
	int			lastcontig;

	/* var to track which area to blowout next */
	int		blowout;

	/* handy/hack place for this */
	char	*vname;
	char	*base;
	char	*dir;
	float	uscale,vscale;
	int		swap;

	FILE	*tri_h,*tri_c,*vtx_c;
	FILE	*dl_h,*dl_c;
	FILE	*mtx_h,*mtx_c;
} VtxCache;

void	traverse_model(VtxCache *,Model *);
void	dump_model(VtxCache *,Model *);
int		push_matrix(VtxCache *,Model *);
void	pop_matrix(VtxCache *,Model *);
void	push_mtltxt(VtxCache *,Model *);
void	pop_mtltxt(VtxCache *,Model *);

void	init_cache(VtxCache *);
int		flush_cache(VtxCache *,Mesh *);
int		add_cache(VtxCache *,Mesh *,int);
int		find_best_point(VtxCache *,Mesh *);
int		find_tris_completed(VtxCache *,Mesh *);

void	output_mtltxt(VtxCache *,Model *);
void	output_vertex(VtxCache *,int,Mesh *);
void	output_tris_completed(VtxCache *,Mesh *);
void	output_bbox(VtxCache *,Mesh *);
void	print_bboxv(FILE *,float *);

int	cmpintinc();
int	cmpintdec();
int	incr_cref();
int	decr_cref();
