
void	mkmat_srt( dst, sx,sy,sz, rx,ry,rz, tx,ty,tz )
Mtx		*dst;
float	sx,sy,sz;
float	rx,ry,rz;
float	tx,ty,tz;
{
	register	float	c, s;
	register	float	t;
	register	u32		i,ti;
	register	float	m[4][4];
	Mtx_i	*Mi;
	Mtx_f	*Mf;

	          m[0][1] = m[0][2] =           0.0;
	m[1][0] =           m[1][2] =           0.0;
	m[2][0] = m[2][1] =                     0.0;

	/* scale */
	m[0][0] = sx; m[1][1] = sy; m[2][2] = sz; m[3][3] = 1.0;

	/* rot x */
	c = fcos((double)DTOR(rx)); s = fsin((double)DTOR(rx));

   	t = m[0][1];
   	m[0][1] = t*c - m[0][2]*s;
   	m[0][2] = t*s + m[0][2]*c;

   	t = m[1][1];
   	m[1][1] = t*c - m[1][2]*s;
   	m[1][2] = t*s + m[1][2]*c;

   	t = m[2][1];
   	m[2][1] = t*c - m[2][2]*s;
   	m[2][2] = t*s + m[2][2]*c;

	/* rot x */
	c = fcos ((double)DTOR(ry));	s = fsin ((double)DTOR(ry));

   	t = m[0][0];
   	m[0][0] = t*c + m[0][2]*s;
   	m[0][2] = m[0][2]*c - t*s;

   	t = m[1][0];
   	m[1][0] = t*c + m[1][2]*s;
   	m[1][2] = m[1][2]*c - t*s;

   	t = m[2][0];
   	m[2][0] = t*c + m[2][2]*s;
   	m[2][2] = m[2][2]*c - t*s;

	/* rotz */
	c = fcos ((double)DTOR(rz));	s = fsin ((double)DTOR(rz));

   	t = m[0][0];
   	m[0][0] = t*c - m[0][1]*s;
   	m[0][1] = t*s + m[0][1]*c;

   	t = m[1][0];
   	m[1][0] = t*c - m[1][1]*s;
   	m[1][1] = t*s + m[1][1]*c;

   	t = m[2][0];
   	m[2][0] = t*c - m[2][1]*s;
   	m[2][1] = t*s + m[2][1]*c;

	m[3][0] = tx; m[3][1] = ty; m[3][2] = tz;

	Mi = (Mtx_i *)&(dst->m[0][0]);
	Mf = (Mtx_f *)&(dst->m[2][0]);

	ti = (m[0][0] * 65536.0);
	Mi->x0 = ( ti >> 16 ) & 0xFFFF;
	Mf->x0 = ti & 0xFFFF;

	ti = (m[1][0] * 65536.0);
	Mi->x1 = ( ti >> 16 ) & 0xFFFF;
	Mf->x1 = ti & 0xFFFF;

	ti = (m[2][0] * 65536.0);
	Mi->x2 = ( ti >> 16 ) & 0xFFFF;
	Mf->x2 = ti & 0xFFFF;

	ti = (m[3][0] * 65536.0);
	Mi->xt = ( ti >> 16 ) & 0xFFFF;
	Mf->xt = ti & 0xFFFF;

	ti = (m[0][1] * 65536.0);
	Mi->y0 = ( ti >> 16 ) & 0xFFFF;
	Mf->y0 = ti & 0xFFFF;

	ti = (m[1][1] * 65536.0);
	Mi->y1 = ( ti >> 16 ) & 0xFFFF;
	Mf->y1 = ti & 0xFFFF;

	ti = (m[2][1] * 65536.0);
	Mi->y2 = ( ti >> 16 ) & 0xFFFF;
	Mf->y2 = ti & 0xFFFF;

	ti = (m[3][1] * 65536.0);
	Mi->yt = ( ti >> 16 ) & 0xFFFF;
	Mf->yt = ti & 0xFFFF;

	ti = (m[0][2] * 65536.0);
	Mi->z0 = ( ti >> 16 ) & 0xFFFF;
	Mf->z0 = ti & 0xFFFF;

	ti = (m[1][2] * 65536.0);
	Mi->z1 = ( ti >> 16 ) & 0xFFFF;
	Mf->z1 = ti & 0xFFFF;

	ti = (m[2][2] * 65536.0);
	Mi->z2 = ( ti >> 16 ) & 0xFFFF;
	Mf->z2 = ti & 0xFFFF;

	ti = (m[3][2] * 65536.0);
	Mi->zt = ( ti >> 16 ) & 0xFFFF;
	Mf->zt = ti & 0xFFFF;

	Mi->w0 = Mi->w1 = Mi->w2 = 0; Mi->w = 1;
	Mf->w0 = Mf->w1 = Mf->w2 = 0; Mf->w = 0;
}
